include  hy17P58.inc

ADCDataL	EQU		0AAH
ADCDataH	EQU		ADCDataL+1
RefData1H	EQU		ADCDataL+2
RefData1L	EQU		ADCDataL+3
RefData2H	EQU		ADCDataL+4
RefData2L	EQU		ADCDataL+5
RefData3H	EQU		ADCDataL+6
RefData3L	EQU		ADCDataL+7
RefData4H	EQU		ADCDataL+8
RefData4L	EQU		ADCDataL+9

Y1			EQU		ADCDataL+10
;Y1			EQU		ADCDataL+11
;Y1			EQU		ADCDataL+12
Y0			EQU		ADCDataL+13
;Y0			EQU		ADCDataL+14
;Y0			EQU		ADCDataL+15
RGain		EQU		ADCDataL+16	;BA
;RGain		EQU		ADCDataL+17	;BB
;RGain		EQU		ADCDataL+18	;BC
;RGain		EQU		ADCDataL+19	;BD
CalRL		EQU		ADCDataL+20	;BE
CalRH		EQU		ADCDataL+21	;BFH
TestR		EQU		ADCDataL+22	;C0H
;TestR		EQU		ADCDataL+23	;C1H
;TestR		EQU		ADCDataL+24	;C2H
;TestR		EQU		ADCDataL+25	;C3H
;TestR		EQU		ADCDataL+26	;C4H




MD1			equ		ADCDataL+27	;C5H
MD2			equ		MD1+1       ;C6H
MD3			equ		MD2+1       ;C7H
MDL1		equ		MD3+1       ;C8H
MDL2		equ		MDL1+1      ;C9H
MDL3		equ		MDL2+1      ;CA
MD4			equ		MDL3+1      ;CB
S_REG		equ		MD4+6       ;CC
r_Len		equ		S_REG+1     ;CD
TableBuf	EQU		r_Len+1		;CE

Y2			EQU		TableBuf+1	;CF
;Y2			EQU		TableBuf+1	;D0
;Y2			EQU		TableBuf+1	;D1
TestR2		EQU		TableBuf+4	;D2H
;TestR2		EQU		ADCDataL+23	;D3H
;TestR2		EQU		ADCDataL+24	;D4H
;TestR2		EQU		ADCDataL+25	;D5H
;TestR2		EQU		ADCDataL+26	;D6H

ExtRH		EQU		3H
ExtRL		EQU		0D7H		

DEFINE       Test=1           ;1=ICE   0=Body

org	00H
	JMP	main
org	04H
	RETI
	
main:
	

	CALL	ClearMEM
	CALL	ClearMEM100
	CALL	ClearMEM200
	MVL		ExtRL
	MVF		CalRL,F,A
	MVL		ExtRH
	MVF		CalRH,F,A
	MVL		67H
	MVF		CSFCN0,F,A
	CALL	SysInit
	CALL	SinCode50k
	NOPF	SinCode50k
LBSR	1	
	MVL		01H
	MVF		IQ0,F,B
	MVL		03H
	MVF		DGCON1,F,B
	MVL		1FH
	MVF		DGCON2,F,B
	MVL		10H
	IORF	DGCON1,F,B
LBSR	0

main_loop:
;外部校正電阻1K測試
IF  Test=1
	MVL		02H
	MVF		PGANET5,F,A
	MVL		48H
	MVF		PGANET3,F,A
	MVL		0A6H
	MVF		AD1CN3,F,A
ENDIF	
IF  Test=0
	MVL		05H
	MVF		PGANET5,F,A
	MVL		0C0H
	MVF		PGANET3,F,A
	MVL		055H
	MVF		AD1CN3,F,A
ENDIF	
	CALL	IQDemodulator
	MVFF	98H,Y0+0
	MVFF	98H+1,Y0+1
	MVFF	98H+2,Y0+2
;手體脂測
IF  Test=1
	MVL		03H
	MVF		PGANET5,F,A
	MVL		48H
	MVF		PGANET3,F,A
	MVL		0B6H
	MVF		AD1CN3,F,A
ENDIF	
IF  Test=0
	MVL		02H
	MVF		PGANET5,F,A
	MVL		84H
	MVF		PGANET3,F,A
	MVL		086H
	MVF		AD1CN3,F,A
ENDIF
	CALL	IQDemodulator
	MVFF	98H,Y1+0
	MVFF	98H+1,Y1+1
	MVFF	98H+2,Y1+2
;腳體脂測
IF  Test=1
	MVL		02H
	MVF		PGANET5,F,A
	MVL		50H
	MVF		PGANET3,F,A
	MVL		0A9H
	MVF		AD1CN3,F,A
ENDIF
IF  Test=0
	MVL		04H
	MVF		PGANET5,F,A
	MVL		88H
	MVF		PGANET3,F,A
	MVL		0A9H
	MVF		AD1CN3,F,A
ENDIF
	CALL	IQDemodulator
	MVFF	98H,Y2+0
	MVFF	98H+1,Y2+1
	MVFF	98H+2,Y2+2
;手部電阻Gain計算
;避免Gain為小數，所以先把Y1放大65536
	CLRF	Y1-2,A
	CLRF	Y1-1,A
	MVL		Y1-2
	MVF		md1,F,A
	MVL		Y0
	MVF		md2,F,A
	MVL		RGain
	MVF		md3,F,A
	MVL		5
	MVF		mdl1,F,A
	MVL		3
	MVF		mdl2,F,A
	MVL		4
	MVF		mdl3,F,A
	MVL		0F0H
	MVF		md4,F,A
	call	divide
;RGain*外部1K實際?65536 即是手部阻抗
	MVL		CalRL
	MVF		md1,F,A
	MVL		RGain
	MVF		md2,F,A
	MVL		TestR
	MVF		md3,F,A
	MVL		2
	MVF		mdl1,F,A
	MVL		3
	MVF		mdl2,F,A
	CALL	multiply
	
;腳部電阻Gain計算
;避免Gain為小數，所以先把Y2放大65536
	CLRF	Y2-2,A
	CLRF	Y2-1,A
	MVL		Y2-2
	MVF		md1,F,A
	MVL		Y0
	MVF		md2,F,A
	MVL		RGain
	MVF		md3,F,A
	MVL		5
	MVF		mdl1,F,A
	MVL		3
	MVF		mdl2,F,A
	MVL		4
	MVF		mdl3,F,A
	MVL		0F0H
	MVF		md4,F,A
	call	divide
;RGain*外部1K實際?65536 即是腳部阻抗
	MVL		CalRL
	MVF		md1,F,A
	MVL		RGain
	MVF		md2,F,A
	MVL		TestR2
	MVF		md3,F,A
	MVL		2
	MVF		mdl1,F,A
	MVL		3
	MVF		mdl2,F,A
	CALL	multiply	
	
	
	
	
;乘完後由於先前放大過65536倍，所以最?個byte捨去	
;先顯示手部阻
LBSR	1	
	MVF		TestR+2,W,A
	CALL	LDISP
	MVF		LCD5,F,B
	SWPF	TestR+2,W,A
	CALL	LDISP
	MVF		LCD4,F,B
	MVF		TestR+3,W,A
	CALL	LDISP
	MVF		LCD3,F,B
	SWPF	TestR+3,W,A
	CALL	LDISP
	MVF		LCD2,F,B
	MVF		TestR+4,W,A
	CALL	LDISP
	MVF		LCD1,F,B
	SWPF	TestR+4,W,A
	CALL	LDISP
	MVF		LCD0,F,B
	
	MVL		01H
	MVF		LCD8,F,B
	
	CALL	Delay
	CALL	Delay
	CALL	Delay
	CALL	Delay
;再'示腳部阻?
	MVF		TestR2+2,W,A
	CALL	LDISP
	MVF		LCD5,F,B
	SWPF	TestR2+2,W,A
	CALL	LDISP
	MVF		LCD4,F,B
	MVF		TestR2+3,W,A
	CALL	LDISP
	MVF		LCD3,F,B
	SWPF	TestR2+3,W,A
	CALL	LDISP
	MVF		LCD2,F,B
	MVF		TestR2+4,W,A
	CALL	LDISP
	MVF		LCD1,F,B
	SWPF	TestR2+4,W,A
	CALL	LDISP
	MVF		LCD0,F,B
	
	
	MVL		03H
	MVF		LCD8,F,B
	CALL	Delay
	CALL	Delay
jmp	main_loop




	
IQDemodulator:	
LBSR	1
IF  Test=1	
	CLRF	IQ0,B		;IQ0=00H
	CLRF	IQ1,B
	BSF		IQ1,2,B		;IQ1=04H
	BSF		IQ0,0,B		;IQ0=01H
	CALL	GetADC
	MVFF	ADCDataL,RefData1L
	MVFF	ADCDataH,RefData1H
	
	BSF		IQ1,0,B	;IQ1=05H
	CALL	GetADC
	MVFF	ADCDataL,RefData2L
	MVFF	ADCDataH,RefData2H
	
	CLRF	IQ0,B		;IQ0=00H
	MVL		0AH
	MVF		IQ1,F,B
	BSF		IQ0,0,B		;IQ0=01H
	CALL	GetADC
	MVFF	ADCDataL,RefData3L
	MVFF	ADCDataH,RefData3H
	
	BSF		IQ1,0,B
	CALL	GetADC
	MVFF	ADCDataL,RefData4L
	MVFF	ADCDataH,RefData4H
ENDIF
IF	Test=0
	CLRF	IQ0,B		;IQ0=00H
	CLRF	IQ1,B
	BSF		IQ1,2,B		;IQ1=04H
	BSF		IQ0,0,B		;IQ0=01H
	CALL	GetADC
	MVFF	ADCDataL,RefData1L
	MVFF	ADCDataH,RefData1H
	
	BSF		IQ1,0,B	;IQ1=05H
	CALL	GetADC
	MVFF	ADCDataL,RefData2L
	MVFF	ADCDataH,RefData2H
	
	CLRF	IQ0,B		;IQ0=00H
	MVL		06H
	MVF		IQ1,F,B
	BSF		IQ0,0,B		;IQ0=01H
	CALL	GetADC
	MVFF	ADCDataL,RefData3L
	MVFF	ADCDataH,RefData3H
	
	BSF		IQ1,0,B
	CALL	GetADC
	MVFF	ADCDataL,RefData4L
	MVFF	ADCDataH,RefData4H
ENDIF	
	
	
	BCF		MSTAT,C,A
	MVF		RefData2L,W,A
	SUBC	RefData1L,F,A
	MVF		RefData2H,W,A
	SUBC	RefData1H,F,A
	
	BCF		MSTAT,C,A
	MVF		RefData4L,W,A
	SUBC	RefData3L,F,A
	MVF		RefData4H,W,A
	SUBC	RefData3H,F,A
LBSR	0	
	MVFF	RefData1L,80H
	MVFF	RefData1H,81H
	MVFF	RefData3L,82H
	MVFF	RefData3H,83H
	CALL	cordic
	NOPF	cordic
	RET

	
	
	
GetADC:
	BCF		INTF0,5,A
	BSF		AD1CN0,0,A
GetADC_Wait:	
	BTSS	INTF0,5,A
	JMP		GetADC_Wait
	MVFF	AD1L,ADCDataL	;不用也要搬過資料才行
	MVFF	AD1M,ADCDataL
	MVFF	AD1H,ADCDataH
	ret
;-----------------------------------------------------------------------------
; SysInit
;-----------------------------------------------------------------------------
SysInit:
	
LBSR	1

	MVL		83H
	MVF		CSFCN1,F,A
	MVL		03H
	MVF		OSCCN2,F,A
	MVL		01H
	MVF		OSCCN0,F,A
	MVL		10H
	MVF		OSCCN1,F,A
	

	
	MVL		00H
	MVF		PT1DA,F,A
	MVL		07H
	MVF		PT1PU,F,A
	MVL		80H
	MVF		PT2DA,F,A
	MVL		0F0H
	MVF		PT4DA,F,B
	MVL		0FH
	MVF		PT5DA,F,B
	
	
	MVL		0C8H
	MVF		LCDCN1,F,B
	MVL		000H
	MVF		LCDCN2,F,B
	MVL		0FFH
	MVF		LCDCN3,F,B
	MVL		0FFH
	MVF		LCDCN4,F,B
	MVL		0FFH
	MVF		LCDCN5,F,B
	MVL		0FFH
	MVF		LCDCN6,F,B
	MVL		0FFH
	MVF		LCDCN7,F,B
	MVL		0FFH
	MVF		LCDCN8,F,B
	
	MVL		83H
	MVF		PWRCN,F,A
	
	MVL		03H
	MVF		AD1CN1,F,A
	MVL		40H
	MVF		AD1CN4,F,A
	MVL		90H
	MVF		AD1CN5,F,A
	MVL		87H
	MVF		AD1CN0,F,A


	
	MVL		0DH
	MVF		BIACN0,F,A
	MVL		01H
	MVF		DACCN0,F,A
	MVL		0BH
	MVF		DACCN1,F,A
	MVL		03H
	MVF		OP1CN0,F,A
	MVL		11H
	MVF		PGACN0,F,A
	MVL		04H
	MVF		PGACN1,F,A
IF  Test=1	
	MVL		80H
ENDIF
IF	Test=0
	MVL		10H
ENDIF
	MVF		PGANET1,F,A		;ICE=80   BODY=10
	MVL		01H
	MVF		PGANET2,F,A
	MVL		0H
	MVF		OP2CN0,F,A
	MVL		0H
	MVF		OP2NET,F,A
LBSR	0	
	RET


SinCode50k:
	MVL		3
	MVF		FSR0H,F,A
	MVL		00H
	MVF		FSR0L,F,A
	MVL		80H
	MVF		POINC0,F,A
	MVL		83H
	MVF		POINC0,F,A
	MVL		86H
	MVF		POINC0,F,A
	MVL		89H
	MVF		POINC0,F,A
	MVL		8bH
	MVF		POINC0,F,A
	MVL		8dH
	MVF		POINC0,F,A
	MVL		8fH
	MVF		POINC0,F,A
	MVL		90H
	MVF		POINC0,F,A
	MVL		90H
	MVF		POINC0,F,A
	MVL		90H
	MVF		POINC0,F,A
	MVL		8fH
	MVF		POINC0,F,A
	MVL		8dH
	MVF		POINC0,F,A
	MVL		8bH
	MVF		POINC0,F,A
	MVL		89H
	MVF		POINC0,F,A
	MVL		86H
	MVF		POINC0,F,A
	MVL		83H
	MVF		POINC0,F,A
	MVL		80H
	MVF		POINC0,F,A
	MVL		7dH
	MVF		POINC0,F,A
	MVL		79H
	MVF		POINC0,F,A
	MVL		77H
	MVF		POINC0,F,A
	MVL		75H
	MVF		POINC0,F,A
	MVL		73H
	MVF		POINC0,F,A
	MVL		71H
	MVF		POINC0,F,A
	MVL		70H
	MVF		POINC0,F,A
	MVL		70H
	MVF		POINC0,F,A
	MVL		70H
	MVF		POINC0,F,A
	MVL		71H
	MVF		POINC0,F,A
	MVL		73H
	MVF		POINC0,F,A
	MVL		75H
	MVF		POINC0,F,A
	MVL		77H
	MVF		POINC0,F,A
	MVL		79H
	MVF		POINC0,F,A
	MVL		7dH
	MVF		POINC0,F,A
	ret



;-----------------------------------------------------------------------------
; Clear Memory
; 080H~0FFH
;-----------------------------------------------------------------------------
ClearMEM:
  CLRF FSR0H,A
  MVL  080H
  MVF  FSR0L,F,ACCE
  MVL  080H
ClriniMen0:
  CLRF INDF0,ACCE
  INF  FSR0L,F,ACCE
  DCSZ WREG,F,ACCE
  JMP  ClriniMen0
  RET
;-----------------------------------------------------------------------------
; Clear Memory
; 100H~17FH
;-----------------------------------------------------------------------------
ClearMEM100:
  MVL  High 100H
  MVF  FSR0H,F,ACCE
  MVL  Low 100H
  MVF  FSR0L,F,ACCE
  MVL  080H
ClriniMen100:
  CLRF INDF0,ACCE
  INF  FSR0L,F,ACCE
  DCSZ WREG,F,ACCE
  JMP  ClriniMen100
  RET
;-----------------------------------------------------------------------------
; Clear Memory
; 200H~2FFH
;-----------------------------------------------------------------------------
ClearMEM200:
  MVL  High 200H
  MVF  FSR0H,F,ACCE
  MVL  Low 200H
  MVF  FSR0L,F,ACCE
  MVL  0FFH
ClriniMen200:
  CLRF INDF0,ACCE
  INF  FSR0L,F,ACCE
  DCSZ WREG,F,ACCE
  JMP  ClriniMen200
  RET  
;-----------------------------------------------------------------------------
; Clear Memory
; 380H~2FFH
;-----------------------------------------------------------------------------
ClearMEM300:
  MVL  High 380H
  MVF  FSR0H,F,ACCE
  MVL  Low 380H
  MVF  FSR0L,F,ACCE
  MVL  080H
ClriniMen300:
  MVL  00H
  MVF  POINC0,F,ACCE
  ;CLRF INDF0,ACCE
  ;INF  FSR0L,F,ACCE
  DCSZ WREG,F,ACCE
  JMP  ClriniMen300
  RET   
;------------------------------------------------------------------------------
Delay:
        mvl     0ffh
        mvf     FSR0L,F,ACCE
     Delay420ms_2:   
        mvl     0ffh
     Delay420ms_1:   
        dcsz    WREG,F,ACCE
        jmp     Delay420ms_1
        dcsz    FSR0L,F,ACCE
        jmp     Delay420ms_2
        ret	

include		math.asm
include		LCDINDX_HYCON.asm
include		cordicsim.obj  